﻿Imports System
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.Design
Imports System.Web.UI.WebControls
Imports System.Web.UI.Design.WebControls
Imports System.Collections
Imports System.ComponentModel
Imports System.ComponentModel.Design
Imports System.Drawing.Design

Namespace WebControls.Design
    ''' <summary>
    ''' 定義 TBDateEdit 控制項智慧標籤面板的動作清單集合。
    ''' </summary>
    Public Class TBDateEditActionList
        Inherits DesignerActionList

        ''' <summary>
        ''' 建構函式。
        ''' </summary>
        Public Sub New(ByVal owner As ControlDesigner)
            MyBase.New(owner.Component)
        End Sub

        ''' <summary>
        ''' 設定物件的屬性值。
        ''' </summary>
        ''' <param name="Component">屬性值將要設定的物件。</param>
        ''' <param name="PropertyName">屬性名稱。</param>
        ''' <param name="Value">新值。</param>
        Private Sub SetPropertyValue(ByVal Component As Object, ByVal PropertyName As String, ByVal Value As Object)
            Dim Prop As PropertyDescriptor = TypeDescriptor.GetProperties(Component).Item(PropertyName)
            Prop.SetValue(Component, Value)
        End Sub

        ''' <summary>
        ''' 取得物件的屬性值。
        ''' </summary>
        ''' <param name="Component">具有要擷取屬性的物件。</param>
        ''' <param name="PropertyName">屬性名稱。</param>
        Private Function GetPropertyValue(ByVal Component As Object, ByVal PropertyName As String) As Object
            Dim Prop As PropertyDescriptor = TypeDescriptor.GetProperties(Component).Item(PropertyName)
            Return Prop.GetValue(Component)
        End Function

        ''' <summary>
        ''' 是否引發 PostBack 動作。
        ''' </summary>
        Public Property AutoPostBack() As Boolean
            Get
                Return CType(GetPropertyValue(Me.Component, "AutoPostBack"), Boolean)
            End Get
            Set(ByVal value As Boolean)
                SetPropertyValue(Me.Component, "AutoPostBack", value)
            End Set
        End Property

        ''' <summary>
        ''' 日期選單樣式。
        ''' </summary>
        Public Property CalendarStyle() As TBDateEdit.ECalendarStyle
            Get
                Return CType(GetPropertyValue(Me.Component, "CalendarStyle"), TBDateEdit.ECalendarStyle)
            End Get
            Set(ByVal value As TBDateEdit.ECalendarStyle)
                SetPropertyValue(Me.Component, "CalendarStyle", value)
            End Set
        End Property

        ''' <summary>
        ''' 日期選單語系。
        ''' </summary>
        Public Property Lang() As TBDateEdit.ELang
            Get
                Return CType(GetPropertyValue(Me.Component, "Lang"), TBDateEdit.ELang)
            End Get
            Set(ByVal value As TBDateEdit.ELang)
                SetPropertyValue(Me.Component, "Lang", value)
            End Set
        End Property

        ''' <summary>
        ''' 是否顯示時間。
        ''' </summary>
        Public Property ShowTime() As Boolean
            Get
                Return CType(GetPropertyValue(Me.Component, "ShowTime"), Boolean)
            End Get
            Set(ByVal value As Boolean)
                SetPropertyValue(Me.Component, "ShowTime", value)
            End Set
        End Property

        ''' <summary>
        ''' 傳回活動清單項目。
        ''' </summary>
        Public Overrides Function GetSortedActionItems() As System.ComponentModel.Design.DesignerActionItemCollection
            Dim oItems As New DesignerActionItemCollection()

            oItems.Add(New DesignerActionPropertyItem("AutoPostBack", _
                "AutoPostBack", "Behavior", "是否引發 PostBack 動作。"))
            oItems.Add(New DesignerActionPropertyItem("CalendarStyle", _
                "日期選單樣式", "Appearance", "日期選單樣式。"))
            oItems.Add(New DesignerActionPropertyItem("Lang", _
                "日期選單語系", "Appearance", "日期選單語系。"))
            oItems.Add(New DesignerActionPropertyItem("ShowTime", _
                "顯示時間", "Appearance", "是否顯示時間。"))
            Return oItems
        End Function
    End Class
End Namespace